/***************************************************************

PROGRAM TO GENERATE TABLE 2

****************************************************************/

new;
rndseed 40558304;


nboot = 1000;
dataset = "c:\\gauss50\\npiv\\Fisher-Schultz\\Table2";
 open fy=^dataset;
 n = rowsf(fy);
 yz=readr(fy,n);
 close(fy);

sel = (yz[.,4] .>= 11).*(yz[.,4] .<= 23);  @ ***** Select observations in specified experience range ***** @
yz = selif(yz,sel);
x = yz[.,2];
y = yz[.,3];
n = rows(y);

eyx = zeros(18,1);
px = zeros(18,1);

@ ***** COMPUTE CONDITIONAL EXPECTATIONS and P[X=X(j)]***** @

j=1;
do until j > 18;
  
  denom = sumc((x .== j));
  eyx[j] = 0;
  if denom > 0;
   eyx[j] = (sumc(y.*(x .== j)))/denom;
   endif;
  px[j] = meanc((x .== j));
  j = j + 1;
  endo;

pjk = sumc(px[12:16]);

el = 1;
trm1 = 0;
do until el > 11;
  trm1 = trm1 + (eyx[16] - eyx[el])*px[el];
  el = el + 1;
  endo;

trm1 = trm1 + (eyx[16] - eyx[12])*pjk;

el = 17;
trm2 = 0;
do until el > 18;
  trm2 = trm2 + (eyx[el] - eyx[12])*px[el];
  el = el + 1;
  endo;
 
gjk = trm1 + trm2;

@ ***** COMPUTE BOOTSTRAP CONFIDENCE LIMIT ***** @

iboot = 1;
bgjk = zeros(nboot,1);
do until iboot > nboot;

   xydat = y~x;
   btrm = n*rndu(n,1);
   btrm = ceil(btrm);
   xyboot = xydat[btrm,.];
   ybt = xyboot[.,1];
   xbt = xyboot[.,2];

beyx = zeros(18,1);
bpx = zeros(18,1);

@ ***** COMPUTE CONDITIONAL EXPECTATIONS and P[X=X(j)]***** @

j=1;
do until j > 18;
  
  denom = sumc((xbt .== j));
  beyx[j] = 0;
  if denom > 0;
   beyx[j] = (sumc(ybt.*(xbt .== j)))/denom;
   endif;
  bpx[j] = meanc((xbt .== j));
  j = j + 1;
  endo;

bpjk = sumc(bpx[12:16]);

el = 1;
trm1 = 0;
do until el > 11;
  trm1 = trm1 + (beyx[16] - beyx[el])*bpx[el];
  el = el + 1;
  endo;

trm1 = trm1 + (beyx[16] - beyx[12])*bpjk;

el = 17;
trm2 = 0;
do until el > 18;
  trm2 = trm2 + (beyx[el] - beyx[12])*bpx[el];
  el = el + 1;
  endo;
 
bgjk[iboot] = trm1 + trm2;
iboot = iboot + 1;
endo;

bgjk = sortc(bgjk,1);
trm = 0.95*nboot;
bnd = bgjk[trm];
gjk;; bnd;
