for grade=1:2,

for subject=1:2,

	clearvars -except grade subject

	if grade == 1 & subject == 2
		M = dlmread('fourthdata.txt', '\t', 1, 0);
	end;
	
	
	M = sortrows(M,4);
	index = max(find(M(:,4) <= 3));
	M = M(1:index,:);
	
	
	if subject == 2
		y = M(:,3);
	end;
	
	z = M(:,4);
	w = M(:,5);
	
	x = x / (max(x) - min(x));
	w = w / (max(w) - min(w));
	z = z / (max(z) - min(z));
	
	n = size(y,1);
	
% declare constants
	hw = 1.7*1.3643*2.0362*n^(-0.2)*min(std(w),(quantile(w,.75)-quantile(w,.25))/1.349); 
	hx = 1.7*1.3643*2.0362*n^(-0.2)*min(std(x),(quantile(x,.75)-quantile(x,.25))/1.349); 
	hy = 1.7*1.3643*2.0362*n^(-0.2)*min(std(y),(quantile(y,.75)-quantile(y,.25))/1.349);
	hz = 1.7*1.3643*2.0362*n^(-0.2)*min(std(z),(quantile(z,.75)-quantile(z,.25))/1.349);

% define Gaussian kernel
	indicator = @(a,b,zeta) and(a<=zeta,zeta<=b);
	kernel = @(u,zeta,h)15/16*(1-(u/h)^2)^2*indicator(0,1,abs(u/h))

% define integral operator kernel

	intkernel = @(z1,z2)1 + 2 * z1 * z2^2;

% define a Legendre polynomial basis for L2[0,1]

	L = 25;
	J = L;

	psij = cell(25,1);
	
	for j=1:25,
		if mod(j,2) == 0,
			psij(j) = {@(x) sqrt(2)*sin(floor((j)/2)*(2*pi*x))};
		end;
		if mod(j,2) == 1,
			psij(j) = {@(x) sqrt(2)*cos(floor((j)/2)*(2*pi*x))};
		end;
		if j == 1,
			psij(j) = {@(x) 1};
		end;
		
	end;
	
% Legendre-type polynomials for L_2[0,1]^2, from the above.
	phij = cell(25,1);
	
	for j=1:5,
		for k=1:5,
			phij(5*(j-1)+k) = {@(x)psij{j}(x(1))*psij{k}(x(2))};
		end;
	end;

	
% initalize some grids
	meshgridptw = w;
	meshlengthw = size(meshgridptw,1);  % initialize the grid for the integration

	meshgridptz = z;
	meshlengthz = size(meshgridptz,1);  % initialize the grid for the integration

	meshgridptSn = [.1 .3 .5 .7 .9];	
	meshlengthSn = size(meshgridptSn,2);

% precompute some kernel density quantities
	kernelcomputexSn(1:meshlengthSn, 1:n) = 0;
	kernelcomputewSn(1:meshlengthSn, 1:n) = 0;
	kernelcomputezSn(1:meshlengthSn, 1:n) = 0;
	for meshpt=1:meshlengthSn,

		for j=1:n,

			kernelcomputexSn(meshpt,j) = kernel(meshgridptSn(meshpt)-x(j),meshgridptSn(meshpt),hx);
			kernelcomputewSn(meshpt,j) = kernel(meshgridptSn(meshpt)-w(j),meshgridptSn(meshpt),hw);
			kernelcomputezSn(meshpt,j) = kernel(meshgridptSn(meshpt)-z(j),meshgridptSn(meshpt),hz);

		end;

	end;
		
	kernelcomputexdata(1:n, 1:n) = 0;
	kernelcomputewdata(1:n, 1:n) = 0;
	kernelcomputezdata(1:n, 1:n) = 0;
	for i=1:n,

		for j=1:n,

			kernelcomputewdata(i,j) = kernel(meshgridptw(i)-w(j),meshgridptw(i),hw);
			kernelcomputezdata(i,j) = kernel(meshgridptz(i)-z(j),meshgridptz(i),hz);

		end;
		
	end;

% compute the leave one out estimators of f_xzw
	fxzw(1:n,1:meshlengthSn) = 0;

	for i=1:n,

		for meshxj=1:meshlengthSn,

			for j=1:n,

				if j ~= i,

					fxzw(i,meshxj) = fxzw(i,meshxj) + kernelcomputexSn(meshxj,j)*kernelcomputewdata(i,j)*kernelcomputezdata(i,j);

				end;

			end;
			
			fxzw(i,meshxj) = fxzw(i,meshxj)/(n*hx*hw*hz);

		end;
			
	end;

% compute the leave one out estimators of f_z
	termsfz(1:n,1:meshlengthz) = 0;  % initialize the placeholder for the terms of the sums

	for j=1:n,

		for meshj=1:meshlengthz,

			termsfz(j,meshj) = kernelcomputezdata(meshj,j);

		end;
	end;  % calculate the terms of the sums


	fz(1:n,1:meshlengthz) = 0;   % initialize the density estimator

	for i=1:n,

		for meshj=1:meshlengthz,

			for j=1:n,

				if j ~= i,

					fz(i,meshj) = fz(i,meshj) + termsfz(j,meshj);

				end;

			end;
			
			fz(i,meshj) = fz(i,meshj)/(n*hz);

		end;

	end;  % the density estimator


% compute the leave one out estimator of E(Y|Z=z)
	termsG(1:n,1:meshlengthz) = 0;  % initialize the placeholder for the terms of the sums

	for j=1:n,

		for meshj=1:meshlengthz,

			termsG(j,meshj) = y(j)*kernelcomputezdata(meshj,j);


		end;
	end;  % calculate the terms of the sums

	Gz(1:n,1:meshlengthz) = 0;   % initialize the density estimator

	for i=1:n,

		for meshj=1:meshlengthz,

			for j=1:n,

				if j ~= i,

					Gz(i,meshj) = Gz(i,meshj) + termsG(j,meshj);

				end;

			end;

			Gz(i,meshj) = Gz(i,meshj)/(n*hz*fz(i,meshj));

		end;
		
	end;  % the density estimator

% compute the test statistic

Sn(1:meshlengthSn,1:meshlengthSn) = 0;

for meshxj=1:meshlengthSn,

	for meshzj=1:meshlengthSn,

		for i=1:n,
		
			Sn(meshxj,meshzj) = Sn(meshxj,meshzj) + (y(i) - Gz(i,i))*fxzw(i,meshxj)*intkernel(z(i),meshgridptSn(meshzj));
		
		end;

		Sn(meshxj,meshzj) = Sn(meshxj,meshzj)/sqrt(n);

	end;
	
end;

Sn2 = Sn.^2;
teststat = sum(sum(Sn2))/meshlengthSn^2

% compute the critical value

% compute the leave one out estimators of f_zw
	fzw(1:n) = 0;
	
	for i=1:n,

		for j=1:n,

			if j ~= i,

				fzw(i) = fzw(i) + kernelcomputewdata(i,j)*kernelcomputezdata(i,j);

			end;


		end;
		
		fzw(i) = fzw(i)/(n*hw*hz);
		
	end;

% compute the leave one out estimator of E(Y|Z,W)
	termsYZW(1:n,1:meshlengthz) = 0;  % initialize the placeholder for the terms of the sums

	for j=1:n,

		for meshj=1:meshlengthz,

			termsYZW(j,meshj) = y(j)*kernelcomputewdata(meshj,j)*kernelcomputezdata(meshj,j);

		end;
	end;  % calculate the terms of the sums

	EYZW(1:n) = 0;   % initialize the density estimator

	for i=1:n,

		for j=1:n,

			if j ~= i,

				EYZW(i) = EYZW(i) + termsYZW(j,i);

			end;

		end;

		EYZW(i) = EYZW(i)/(n*hw*hz*fzw(i));
	
	end;  % the density estimator

% compute the matrix of residuals
	uhat(1:n) = 0;

	for i=1:n,

		uhat(i) = y(i) - EYZW(i);	

	end;

	Uhatmatrix(1:n,1:n) = 0;
	
	for i=1:n,
	
		Uhatmatrix(i,i) = uhat(i)^2;
	
	end;
	
% compute the normal kernel estimators of f_z
	fz2(1:n) = 0;   % initialize the density estimator

	for i=1:n,

		for j=1:n,

			fz2(i) = fz2(i) + termsfz(j,i);

		end;

		fz2(i) = fz2(i)/(n*hz);


	end;  % the density estimator

% compute the ordinary kernel estimators of f_xzw
	
	clear meshgridptdjk
	meshgridptdjk = meshgridptSn;
	meshlengthdjk = size(meshgridptdjk,2);
	
	fxzw2(1:meshlengthdjk,1:meshlengthdjk,1:meshlengthdjk) = 0;

	for meshxj=1:meshlengthdjk,

		for meshz2j=1:meshlengthdjk,
		
			for meshwj=1:meshlengthdjk,

				for j=1:n,

					fxzw2(meshxj,meshz2j,meshwj) = fxzw2(meshxj,meshz2j,meshwj) + kernelcomputexSn(meshxj,j)*kernelcomputezSn(meshz2j,j)*kernelcomputewSn(meshwj,j);

				end;

				fxzw2(meshxj,meshz2j,meshwj) = fxzw2(meshxj,meshz2j,meshwj)/(n*hx*hz*hw);
				
			end;

		end;
				
	end;

% precompute some parts of the terms of djk and ajk
	phijcompute(1:L,1:meshlengthdjk,1:meshlengthdjk) = 0;
	for j=1:L,

		for dx2=1:meshlengthdjk,

			for dz2=1:meshlengthdjk,

				phijcompute(j,dx2,dz2) = phij{j}([meshgridptdjk(dx2) meshgridptdjk(dz2)]);

			end;

		end;

	end;

	psijcompute(1:L,1:meshlengthdjk) = 0;
	for k=1:L,

		for dz1=1:meshlengthdjk,

			psijcompute(k,dz1) = psij{k}(meshgridptdjk(dz1));

		end;

	end;

	intkernelcompute(1:meshlengthdjk,1:meshlengthdjk) = 0;
	for dz1=1:meshlengthdjk,

		for dz2=1:meshlengthdjk,

			intkernelcompute(dz1,dz2) = intkernel(meshgridptdjk(dz1),meshgridptdjk(dz2));

		end;

	end;

% compute the terms djk
	clear djk
	
	djk(1:L,1:L) = 0;
	for j=1:L,
	
		for k=1:L,
	
			for dx=1:meshlengthdjk,

				for dz1=1:meshlengthdjk,

					for dz2=1:meshlengthdjk,

						for dw=1:meshlengthdjk,		

							djk(j,k) = djk(j,k) + fxzw2(dx,dz2,dw)*intkernelcompute(dz2,dz1)*phijcompute(j,dx,dz1)*phijcompute(k,dz2,dw);
							
						end;

					end;

				end;

			end;
		
			djk(j,k) = djk(j,k)/meshlengthdjk^4;
				
		end;
		
		j
						
	end;
	
% compute the function t-hat
	that(1:meshlengthdjk,1:meshlengthdjk,1:meshlengthdjk) = 0;
	
	for zhat=1:meshlengthdjk,
	
		for x1=1:meshlengthdjk,

			for x2=1:meshlengthdjk,

				for dw=1:meshlengthdjk,
				
					that(zhat,x1,x2) = that(zhat,x1,x2) + fxzw2(x1,zhat,dw)*fxzw2(x2,zhat,dw);
					
				end;
				
				that(zhat,x1,x2) = that(zhat,x1,x2) / meshlengthdjk;

			end;

		end;
		
	end;

% compute the terms ajk
	ajk(1:L,1:L) = 0;
	
	for j=1:L,
	
		for k=1:L,
	
			for dx1=1:meshlengthdjk,

				for dz1=1:meshlengthdjk,

					for dz2=1:meshlengthdjk,		

						for dpsi=1:meshlengthdjk,

							ajk(j,k) = ajk(j,k) + that(dz1,dpsi,dx1)*intkernelcompute(dz1,dz2)*phijcompute(j,dx1,dz2)*psijcompute(k,dz1);

						end;

					end;

				end;

			end;
		
			ajk(j,k) = ajk(j,k)/meshlengthdjk^4;
		
		end;
						
	end;
	

% precompute some parts of the matrix phi
	phijcompute2(1:L,1:n) = 0;
	for i=1:n,
	
		for k=1:L,
		
			phijcompute2(k,i) = phij{k}([z(i) w(i)]);
			
		end;
		
	end;

	psicompute2(1:L,1:n) = 0;
	for i=1:n,
	
		for k=1:L,
		
			psicompute2(k,i) = psij{k}(z(i));
		
		end;
		
	end;

% compute the matrix phi
	phimatrix(1:n,1:L) = 0;

	for i=1:n,

		for j=1:L,

			for k=1:L,

				phimatrix(i,j) = phimatrix(i,j) + djk(j,k)*phijcompute2(k,i)-ajk(j,k)*psicompute2(k,i)/fz2(i);
				
			end;
		
			phimatrix(i,j) = phimatrix(i,j)/sqrt(n);

		end;


	end;

% compute the eigenvalues
	eigenvalues = real(sort(eig(phimatrix'*Uhatmatrix*phimatrix),'descend'));

	critvalsim(1:100000) = 0;
	for rep=1:100000,

		chisquaredraws = chi2rnd(1,1,J);
		critvalsim(rep) = chisquaredraws*eigenvalues;

	end;


	critvalsim = sort(critvalsim);
	
	grade
	subject
	teststat
	criticalvalue90 = critvalsim(.90*100000)
	criticalvalue95 = critvalsim(.95*100000)
	criticalvalue99 = critvalsim(.99*100000)
	
end;

end;


